#!/bin/sh

# 관련 설정
MAX_WORD=5
DIC_FILE='dic.txt'
RESULT_FILE='result.txt'

echo "########################################################################"
echo "#                                                                      #"
echo "#                    RANDOM DOMAIN GENERATOR                           #"
echo "#                                                                      #"
echo "#                     MADE BY WOO-RAM, PARK                            #"
echo "#                                                                      #"
echo "########################################################################"

# 사전 데이터 수량 파악
TOTAL_LINE=`wc -l dic.txt | awk '{ print $1 }'`

# 사전 데이터를 장성적으로 읽었는지 확인한다
if [ $TOTAL_LINE -le 1 ]
then
	echo "[!] Dictionary loading fail..."
	exit
else
	echo "[!] Dictionary loading complete"
	TIME=`date +"%Y/%m/%d %H:%m:%S"`
	echo "RUNNING TIME : $TIME"
	echo "RUNNING TIME : $TIME" >> $RESULT_FILE
fi

while true
do

# 랜덤 문자열 2개 뽑아내기
RAND_NUM=`./rand $TOTAL_LINE`
STRING1=`sed -n "$RAND_NUM~0 p" $DIC_FILE`
RAND_NUM=`./rand $TOTAL_LINE`
STRING2=`sed -n "$RAND_NUM~0 p" $DIC_FILE`

# 문자열을 랜덤하게 쪼갠다
RAND_NUM=`./rand $MAX_WORD`
PART_SRC_STR1=`echo $STRING1 | head -c $RAND_NUM`
RAND_NUM=`./rand $MAX_WORD`
PART_SRC_STR2=`echo $STRING2 | head -c $RAND_NUM`

# 문자열 가공
PART_STR1=`echo $PART_SRC_STR1 | sed -e "s/[\.()\']//g"`
PART_STR2=`echo $PART_SRC_STR2 | sed -e "s/[\.()\']//g"`

# 빈값이 나올경우 컨티뉴
if [ -z $PART_STR1 ]
then
	continue
fi
if [ -z $PART_STR2 ]
then
	continue
fi

FINDED_STR=`echo $PART_STR1$PART_STR2`

#단어가 동시에 한자리씩 나올경우 합쳐서 2자리가 되므로 도메인 구매가 불가능하다
if [ `echo "$FINDED_STR" | wc -c | awk '{ print $1-1 }'` -le 2 ]
then
	continue
fi

WORD_CNT=`echo $FINDED_STR | wc -c | awk '{ print $1-1 }'`

RESULT_STR=`echo $FINDED_STR.com`

COUNT=`lynx -dump "http://reports.internic.net/cgi/whois?whois_nic=$RESULT_STR&type=domain" | grep -c "No match for domain"`

if [ $COUNT -gt 0 ]
then
	YESNO="Y"
else
	YESNO="N"
fi

echo -e "SEARCH WORD : $RESULT_STR($YESNO)\tWORD COUNT : $WORD_CNT\tORIGINAL WORD : $STRING1, $STRING2"
echo -e "SEARCH WORD : $RESULT_STR($YESNO)\tWORD COUNT : $WORD_CNT\tORIGINAL WORD : $STRING1, $STRING2" >> $RESULT_FILE

done
